#include "STC32G.h"
#include "bno08x.h"
#include "intrins.h"
#include "math.h"
#include "USART.H"
#include <STDIO.H>
#define MAIN_Fosc 24000000L // ʱ

typedef unsigned char u8;
typedef unsigned int u16;
typedef unsigned long u32;

/****************************** û ***********************************/

#define Timer0_Reload (65536UL - (MAIN_Fosc / 1000)) // Timer 0 жƵ, 1000/

/*****************************************************************************/

/*************  ر    **************/
bit B_1ms; // 1ms־

/*************  غ    **************/
void delay_ms(u8 ms);

/**********************************************/

typedef struct Quaternion{
    float w, x, y, z; // ʵr鲿i,j,kӦڵλԪijk
} Quaternion;

Quaternion this_q;

float ax = 0, ay = 0, az = 0;
float gx = 0, gy = 0, gz = 0;
float roll = 0, pitch = 0, yaw = 0;

#define M_PI 3.14159265358979323846

void quatToEuler(Quaternion *q, float *yaw, float *pitch, float *roll)
{
	// roll ()رעĸΪ0򻯴ʵӦпҪϸµж
	*roll = atan2(2 * (q->w * q->x + q->y * q->z), q->w * q->w - q->x * q->x - q->y * q->y + q->z * q->z);
	// yaw (ƫ)
	*yaw = atan2(2 * (q->w * q->z - q->x * q->y), 1 - 2 * (q->y * q->y + q->z * q->z));
	// pitch ()
	*pitch = 0;

}

void Delay3us(void)	//@24.000MHz
{
	unsigned long edata i;

	_nop_();
	_nop_();
	_nop_();
	i = 16UL;
	while (i) i--;
}

float wa=0;
void main(void)
{
    WTST = 0;  // óָʱֵΪ0ɽCPUִָٶΪ
    EAXFR = 1; // չĴ(XFR)ʹ
    CKCON = 0; // ߷XRAMٶ
    P_SW2 |= 0x80;
    I2C_Init();
    P0M0 = 0x00;
    P0M1 = 0x00;
    P1M0 = 0x00;
    P1M1 = 0x00;
    P2M0 = 0x00;
    P2M1 = 0x00;

    P3M0 = 0x00;
    P3M1 = 0x00;
    P4M0 = 0x00;
    P4M1 = 0x00;
    P5M0 = 0x00;
    P5M1 = 0x00;
    P6M0 = 0x00;
    P6M1 = 0x00;
    P7M0 = 0x00;
    P7M1 = 0x00;

    AUXR = 0x80; // Timer0 set as 1T, 16 bits timer auto-reload,
    TH0 = (u8)(Timer0_Reload / 256);
    TL0 = (u8)(Timer0_Reload % 256);
    ET0 = 1; // Timer0 interrupt enable
    TR0 = 1; // Tiner0 run
		

	Uart1_Init();

	softReset();
    delay_ms(100);
    enableLinearAccelerometer(3); // 3ms,300hz
    enableGyro(10);
    enableGameRotationVector(3);
    EA = 1; // ж
    while (1)
    {

//			printf("%d\r\n",1);
//        if (B_1ms)
//        {
//            B_1ms = 0;
            if (dataAvailable() == 1)
            {
                ax = getLinAccelX();
                ay = getLinAccelY();
                az = getLinAccelZ();
                gx = getGyroX();
                gy = getGyroY();
                gz = getGyroZ();
                this_q.x = getQuatI();
				this_q.y = getQuatJ();
				this_q.z = getQuatK();
				this_q.w = getQuatReal();
				quatToEuler(&this_q, &yaw, &pitch, &roll);
				wa=yaw*(180/M_PI);
				printf("%f,%f,%f\r\n",roll,yaw,wa);
            }
						
//        }
    }
}


//========================================================================
// : void delay_ms(u8 ms)
// : ʱ
// : ms,Ҫʱms, ֻ֧1~255ms. ԶӦʱ.
// : none.
// 汾: VER1.0
// : 2021-3-9
// ע:
//========================================================================
void delay_ms(u8 ms)
{
    u16 i;
    do
    {
        i = MAIN_Fosc / 6000;
        while (--i)
            ;
    } while (--ms);
}

/********************** Timer0 1msжϺ ************************/
void timer0(void) interrupt 1
{

    B_1ms = 1; // 1ms־
}

/****************************/
